=== debian/changelog ===
bfs (3.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2.

 -- Chris Lamb <lamby@debian.org>  Sat, 15 Jul 2023 16:54:05 +0100
