=== debian/control ===
Source: bfs
Section: utils
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 acl,
 debhelper-compat (= 13),
 libacl1-dev [linux-any],
 libcap-dev [linux-any],
 libonig-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/tavianator/bfs
Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs
Rules-Requires-Root: no

Package: bfs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Breadth-first version of find(1)
 bfs is a variant of the UNIX `find` command that operates breadth-first rather
 than depth-first.
 .
 It tries to be easier to use than `find`, while remaining compatible with
 find(1). For example, bfs is less picky about where you put its arguments.
 bfs also adds some extra options that make some common tasks easier.
 .
 When bfs detects that its output is a terminal, it automatically colors its
 output with the same colors ls uses.
