## bfs 3.0.4

=== debian/changelog ===
bfs (3.0.4-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 21 Oct 2023 09:13:57 +0100

bfs (3.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 09 Sep 2023 09:40:05 -0700
