## bfs 3.1.1

=== debian/changelog ===
bfs (3.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 24 Feb 2024 10:28:49 +0000

bfs (3.1-1) unstable; urgency=medium

  * New upstream release.
  * Add liburing-dev to build-depends.
  * Update debian/docs.

 -- Chris Lamb <lamby@debian.org>  Sun, 11 Feb 2024 13:05:52 -0800
