## bfs 3.1.2

=== debian/changelog ===
bfs (3.1.2-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:33:19 +1100

bfs (3.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sun, 03 Mar 2024 15:51:16 +0000
