=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: bfs
 Section: utils
 Priority: optional
-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  acl,
  debhelper-compat (= 13),
  libacl1-dev [linux-any],
  libcap-dev [linux-any],
  libonig-dev,
+ liburing-dev,
 Standards-Version: 4.6.2
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
