=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Fix FTBFS on kfreebsd-* architectures
# https://github.com/tavianator/bfs/issues/56
ifneq (,$(filter kfreebsd,$(DEB_HOST_ARCH_OS)))
export DEB_CFLAGS_MAINT_APPEND = -DBFS_HAS_SYS_EXTATTR=0
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_test:
ifneq ($(shell id -u),0)
	dh_auto_test
endif

override_dh_installchangelogs:
	dh_installchangelogs docs/CHANGELOG.md
