=== debian/changelog ===
bfs (3.3.1-4) unstable; urgency=medium

  * Correctly (i.e. explicitly) include buildtools.mk in debian/rules; it is
    not yet included by default. Thanks, Helmut. (Closes: #1078525)

 -- Chris Lamb <lamby@debian.org>  Thu, 15 Aug 2024 10:59:41 +0100

bfs (3.3.1-3) unstable; urgency=medium

  * Pass CC to ./configure script to fix cross-build support. Thanks, Helmut!
    (Closes: #1078525)

 -- Chris Lamb <lamby@debian.org>  Mon, 12 Aug 2024 08:44:01 +0100

bfs (3.3.1-2) unstable; urgency=medium

  * Apply patch from upstream to fix FTBFS on riscv64. (Closes: #1072933)

 -- Chris Lamb <lamby@debian.org>  Tue, 11 Jun 2024 10:49:08 +0100

bfs (3.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Tue, 04 Jun 2024 08:26:30 +0100

bfs (3.2-1) unstable; urgency=medium

  * New upstream release.
  * Don't call upstream's (new) configure file.
  * Update renamed Lintian tag.

 -- Chris Lamb <lamby@debian.org>  Wed, 08 May 2024 14:58:05 +0100

bfs (3.1.3-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 09 Mar 2024 09:34:31 +0000
