## bfs 4.0.2

=== debian/changelog ===
bfs (4.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 27 Sep 2024 08:20:05 -0700

bfs (4.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop 0001-PATCH-atomic-Fix-RISC-V-build-with-GCC-14.patch; applied
    upstream.

 -- Chris Lamb <lamby@debian.org>  Sat, 24 Aug 2024 09:51:02 +0100
