## bfs 4.0.3

=== debian/changelog ===
bfs (4.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 25 Oct 2024 10:53:49 -0700
