=== debian/changelog ===
bfs (4.0.4-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 08 Nov 2024 09:34:41 -0800
