## bfs 4.0.5

=== debian/changelog ===
bfs (4.0.5-2) unstable; urgency=medium

  * Fix a test failure due to changes in gawk/bash. (Closes: #1095329)

 -- Chris Lamb <lamby@debian.org>  Sat, 08 Feb 2025 09:39:20 +0000

bfs (4.0.5-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 24 Jan 2025 11:44:24 +0000
