## bfs 4.0.6

=== debian/changelog ===
bfs (4.0.6-1) unstable; urgency=medium

  * New upstream release.
  * Drop 0001-PATCH-tests-Use-if-it-exists.patch; applied upstream.

 -- Chris Lamb <lamby@debian.org>  Fri, 28 Feb 2025 11:01:57 +0000
