=== debian/tests/control ===
Tests: 0001-smoketest
Restrictions: needs-root
