## bfs 4.1

=== Makefile ===
--- 
+++ 
@@ -43,9 +43,11 @@
 BINS := \
     bin/bfs \
     bin/tests/mksock \
+    bin/tests/ptyx \
     bin/tests/units \
     bin/tests/xspawnee \
-    bin/tests/xtouch
+    bin/tests/xtouch \
+    bin/bench/ioq
 
 all: ${BINS}
 .PHONY: all
@@ -90,7 +92,7 @@
 
 ${BINS}:
 	@${MKDIR} ${@D}
-	+${MSG} "[ LD ] $@" ${CC} ${_CFLAGS} ${_LDFLAGS} ${.ALLSRC} ${_LDLIBS} -o $@
+	+${MSG} "[ LD ] $@" ${CC} ${_CFLAGS} ${_LDFLAGS} $^ ${_LDLIBS} -o $@
 	${POSTLINK}
 
 # Get the .c file for a .o file
@@ -103,7 +105,7 @@
 .SILENT: gen/version.i.new
 
 gen/version.i: gen/version.i.new
-	test -e $@ && cmp -s $@ ${.ALLSRC} && ${RM} ${.ALLSRC} || mv ${.ALLSRC} $@
+	test -e $@ && cmp -s $@ $^ && ${RM} $^ || mv $^ $@
 .SILENT: gen/version.i
 
 obj/src/version.o: gen/version.i
@@ -118,6 +120,7 @@
 # Integration test binaries
 ITEST_BINS := \
     bin/tests/mksock \
+    bin/tests/ptyx \
     bin/tests/xtouch
 
 # Build (but don't run) test binaries
@@ -178,6 +181,9 @@
 bin/tests/mksock: obj/tests/mksock.o ${LIBBFS}
 OBJS += obj/tests/mksock.o
 
+bin/tests/ptyx: obj/tests/ptyx.o ${LIBBFS}
+OBJS += obj/tests/ptyx.o
+
 bin/tests/xtouch: obj/tests/xtouch.o ${LIBBFS}
 OBJS += obj/tests/xtouch.o
 
@@ -214,6 +220,14 @@
 	    && ../configure MAKE="${MAKE}" ${DISTCHECK_CONFIG_${@:distcheck-%=%}} \
 	    && ${MAKE} check TEST_FLAGS="--sudo --verbose=skipped"
 	@test "$${GITHUB_ACTIONS-}" != true || printf '::endgroup::\n'
+
+## Benchmarks (`make bench`)
+
+bench: bin/bench/ioq
+.PHONY: bench
+
+bin/bench/ioq: obj/bench/ioq.o ${LIBBFS}
+OBJS += obj/bench/ioq.o
 
 ## Automatic dependency tracking
