=== debian/changelog ===
bfs (4.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2.

 -- Chris Lamb <lamby@debian.org>  Fri, 15 Aug 2025 08:17:09 -0700
