=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  libcap-dev [linux-any],
  libonig-dev,
  liburing-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs
