=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
-include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/default.mk
+include /usr/share/dpkg/buildtools.mk
 
 # Fix FTBFS on kfreebsd-* architectures
 # https://github.com/tavianator/bfs/issues/56
@@ -13,6 +14,9 @@
 %:
 	dh $@
 
+override_dh_auto_configure:
+	./configure 'CC=$(CC)'
+
 override_dh_auto_test:
 ifneq ($(shell id -u),0)
 	dh_auto_test
